<?php

if (!defined('PHPWG_ROOT_PATH')) { die('Hacking attempt!'); }

// ini_set('error_reporting', E_ALL);
// ini_set('display_errors', true);

  global $lang;
  include(get_language_filepath('plugin.lang.php', PHPWG_PLUGINS_PATH.basename(dirname(__FILE__))."/"));


function create_catid_files()
{
  $sql="select id from ".CATEGORIES_TABLE." where dir is not null";
  $result=pwg_query($sql);
  $cats=array();
  while($row=mysql_fetch_row($result))
  { array_push($cats, $row[0]); }

  $dirs=get_fulldirs($cats);
  while(list($key, $val) = each($dirs))
  {
    $handle=fopen($val."/cat_id.dat", "w");
    fwrite($handle, serialize(array("id"=>$key, "dir"=>$val)));
    fclose($handle);
  }
}

function delete_catid_files()
{
  $sql="select id from ".CATEGORIES_TABLE." where dir is not null";
  $result=pwg_query($sql);
  $cats=array();
  while($row=mysql_fetch_row($result))
  { array_push($cats, $row[0]); }

  $dirs=get_fulldirs($cats);
  while(list($key, $val) = each($dirs))
  {
    if(file_exists($val."/cat_id.dat"))
    { unlink($val."/cat_id.dat"); }
  }
}

function plugin_install($plugin_id, $plugin_version, &$errors) 
{
  $site_update_pwg=PHPWG_ROOT_PATH."admin/site_update.php";
  $site_update_async=dirname(__FILE__)."/site_update_async.php";

  if(PHPWG_VERSION == "1.7.0")
  {
    if(copy($site_update_pwg, $site_update_pwg.".ASync-backup"))
    {
      $fhandle=fopen($site_update_async, "r");
      if($fhandle)
      {
        $body=fread($fhandle, filesize($site_update_async));
        fclose($fhandle);
        $body=str_replace("#ASYNC_DIRECTORY#", PHPWG_PLUGINS_PATH.basename(dirname(__FILE__))."/", $body);
         
        $fhandle=fopen($site_update_pwg, "w");
        if($fhandle)
        {
          fwrite($fhandle, $body);
          fclose($fhandle);
          create_catid_files();
          return;
        }
      }
      $errors=l10n('async_error_copy_async');
      return;
    }
    $errors=l10n('async_error_copy_backup');
    return;
  }
  $errors=l10n('async_error_pwg_version');
}

function plugin_uninstall($plugin_id)
{
  $site_update_pwg=PHPWG_ROOT_PATH."admin/site_update.php";

  if(copy($site_update_pwg.".ASync-backup", $site_update_pwg))
  {
    delete_catid_files();
    return;
  }
  $errors=l10n('async_error_restore_backup');
}

function plugin_activate($plugin_id, $plugin_version, &$errors)
{
}

function plugin_deactivate($plugin_id)
{
}


?>
